local M = {}

local function onReset()
  electrics.values['retarderCoef'] = 0
  electrics.values['retarder_input'] = 0
end

local function updateGFX(dt) -- ms
    if electrics.values.retarder_input ~= 0 then
        gui.message({txt = "Retarder coefficient {{percent}}%", context = {percent = electrics.values['retarderCoef']*100}}, 4, "semi.retarder")
    end

    electrics.values['retarderCoef'] = math.min(1, math.max(0, (electrics.values['retarderCoef'] + electrics.values['retarder_input'] * dt)))
end

local function retarderInput(value)
  electrics.values.retarder_input = value

end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.retarderInput = retarderInput

return M
